/*
 *--------------------------------------
 * Program Name: SPLAT
 * Author: LogicalJoe
 * License: (C) LogicalJoe 2019
 * Description: I never put stuff here :/
 * Cemetech Contest Number Twenty-Two
 *--------------------------------------
*/

/* Put all your defines here */
#define Cver 0

/* Put all your includes here */
#include <stdio.h>
#include <graphx.h>
#include <keypadc.h>
#include <compression.h>
#include "gfx/SPLAT_Images.h"

/* Put your function prototypes here */
void Splash(void);      // Display splash
void MoveSplash(void);  // Move splash out of the way
void Help(void);        // Display the help screen
void MenuCurs(uint16_t X, uint8_t Y); // menu cursor
void ModeMenu(void);    // Display the mode menu
void Mode(void);        // Mode menu
void CustomMenu(void);  // Display the Customizer menu
void Custom(void);      // Customizer menu
void Character(uint16_t X, uint8_t Y, uint8_t R);
void Game(void);

/* Put all your globals here */
uint8_t Paint[] = {224,70,62,251,229},Copt[]={0,1,2},Mopt=1,ver;
gfx_sprite_t *SPLAT_logo, *SPLAT_mini;
uint24_t HighS[]={0,0,0};
ti_var_t file;
bool Dark=false;
// Copt : Sub Prot Col

void main(void) {
    /* Fill in the body of the main function here */
    
    // Yay! appvars \o/
    ti_CloseAll();
    file = ti_Open("SplatHs", "r");
    if (file) {
        ti_Read(&ver,  sizeof(ver),   1, file);
        ti_Read(Copt,  sizeof(Copt),  1, file);
        ti_Read(HighS, sizeof(HighS), 1, file);
        ti_Read(&Dark, sizeof(Dark),  1, file);
    }
    
    gfx_SetTransparentColor(239);
    gfx_SetTextFGColor(255*Dark);
    gfx_SetTextBGColor(255*!Dark);
    gfx_SetTextTransparentColor(255*!Dark);
    
    SPLAT_logo = gfx_MallocSprite(SPLAT_logo_width, SPLAT_logo_height);
    zx7_Decompress(SPLAT_logo, SPLAT_logo_compressed);
    
    SPLAT_mini = gfx_MallocSprite(SPLAT_mini_width, SPLAT_mini_height);
    zx7_Decompress(SPLAT_mini, SPLAT_mini_compressed);
    
    gfx_Begin(gfx_8bpp);
    
    Splash();
    
    while (!(kb_Data[6] & kb_Clear)) {
        while (!kb_AnyKey());
        if (kb_Data[4] & kb_Prgm) {
            MoveSplash();
            Help();
            Splash();
            while (kb_AnyKey());
        }
        if (kb_Data[1] & kb_2nd) {
            MoveSplash();
            Mode();
            Splash();
            while (kb_AnyKey());
        }
    }
    
    ti_CloseAll();
    file = ti_Open("SplatHs", "w");
    if (file) {
        ti_Write(&ver,  sizeof(ver),   1, file);
        ti_Write(Copt,  sizeof(Copt),  1, file);
        ti_Write(HighS, sizeof(HighS), 1, file);
        ti_Write(&Dark, sizeof(Dark),  1, file);
    }
    ti_SetArchiveStatus(true, file);
    ti_CloseAll();
    
    gfx_End();
    free(SPLAT_logo);
    free(SPLAT_mini);
}

/* Put other functions here */

void Splash(void) { // NOT Splat.
    gfx_FillScreen(255*!Dark);
    srandom(rtc_Time());
    gfx_TransparentSprite_NoClip(SPLAT_logo,98,25);
    gfx_FloodFill(160,90,Paint[randInt(0, 4)]);
    gfx_SetTextScale(3,4);
    gfx_PrintStringXY("SPLAT",100,160);
    gfx_SetTextScale(1,2);
    gfx_PrintStringXY("by LogicalJoe",114,210);
    gfx_SetTextScale(1,1);
    gfx_PrintStringXY("Press 2nd",127,196);
    gfx_PrintStringXY("CC:22",2,2);
}

void MoveSplash(void) {
    int a;
    for(a=0;a<73;a++) {
        gfx_SetClipRegion(0,158-2*a,320,192-2*a);
        gfx_ShiftUp(2);
        if (a<=24) {
            gfx_SetClipRegion(0,192+a,320,240);
            gfx_ShiftDown(2);
        }
        delay(5);
    }
    gfx_SetClipRegion(0,0,320,240);
}

void Help(void) { // I've done it TvT
    gfx_SetTextScale(1,2);
    gfx_PrintStringXY("- SPLAT Help -",115,55);
    gfx_SetTextScale(1,1);
    gfx_PrintStringXY("Navigate the menus using the",10,75);
    gfx_PrintStringXY("arrow keys and 2nd to select.",15,90);
    gfx_PrintStringXY("Create your avatar and collect",10,105);
    gfx_PrintStringXY("your center color,",15,120);
    gfx_PrintStringXY("Your middle color has no effect,",10,135);
    gfx_PrintStringXY("And your outer color subtracts",10,150);
    gfx_PrintStringXY("from your score.",15,165);
    gfx_PrintStringXY("Press mode to pause the game,",10,180);
    gfx_PrintStringXY("Press prgm for this help screen.",10,195);
    gfx_PrintStringXY("Enjoy!",10,210);
    gfx_PrintStringXY("(C) LogicalJoe 2019",191,232);
    while (kb_AnyKey());
    while (!(kb_Data[6] & kb_Clear) && !(kb_Data[6] & kb_Enter))
        kb_Scan();
    if (kb_Data[6] & kb_Enter) {
        Dark=!Dark;
        gfx_SetTextFGColor(255*Dark);
        gfx_SetTextBGColor(255*!Dark);
        gfx_SetTextTransparentColor(255*!Dark);
        gfx_FillScreen(255*!Dark);
        gfx_SetTextScale(3,4);
        gfx_PrintStringXY("SPLAT",100,14);
    }
}

void MenuCurs(uint16_t X, uint8_t Y) {
    gfx_TransparentSprite_NoClip(SPLAT_mini,X,Y);
}

void ModeMenu(void) {
    int a,b;
    gfx_SetColor(255*Dark);
    gfx_SetTextScale(2,3);
    // 185 pix for boxes
    // 40 pixels per box + 5 pix space
    // text is 21 pixels tall @3x
    gfx_PrintStringXY("CLASSIC MODE",70,64); // 180
    gfx_PrintStringXY("HARDCORE MODE",62,109); // 196
    gfx_PrintStringXY("INFINITY MODE",61,154); // 194
    gfx_PrintStringXY("SCREENSAVER",73,199); // 174
    gfx_SetTextScale(1,1);
    for(a=55,b=0;a<191;a+=45,b++) {
        gfx_Rectangle(57,a,206,40);
        gfx_Rectangle(58,a+1,204,38);
        gfx_SetTextXY(280,a+12);
        if (b!=3) gfx_PrintUInt(HighS[b],4);
    }
}

void Mode(void) {
    uint8_t a;
    ModeMenu();
    MenuCurs(20,45*Mopt+22);
    gfx_FloodFill(28,45*Mopt+30,Paint[randInt(0,4)]);
    while (kb_AnyKey());
    while (!(kb_Data[6] & kb_Clear)) {
        
        kb_Scan();
        if (kb_Data[7]) {
            gfx_SetColor(255*!Dark);
            gfx_FillRectangle_NoClip(20,45*Mopt+22,16,16);
            Mopt+=(kb_Data[7] & kb_Down);
            Mopt-=(kb_Data[7] & kb_Up)/8;
            if (Mopt==5) Mopt=1;
            if (Mopt==0) Mopt=4;
            MenuCurs(20,45*Mopt+22);
            gfx_FloodFill(28,45*Mopt+30,Paint[randInt(0,4)]);
            delay(100);
        }
        if (kb_Data[4] & kb_Prgm) {
            gfx_SetColor(255*!Dark);
            gfx_FillRectangle_NoClip(0,55,320,185); // this can be upgraded
            Help();
            gfx_SetColor(255*!Dark);
            gfx_FillRectangle_NoClip(0,55,320,185); // or not...
            ModeMenu();
            MenuCurs(20,45*Mopt+22);
            gfx_FloodFill(28,45*Mopt+30,Paint[randInt(0,4)]);
            while (kb_AnyKey());
        }
        if (kb_Data[1] & kb_2nd) {
            if (Mopt==4) Game();
            else{
                gfx_FillScreen(255*!Dark);
                Custom();
            }
            gfx_FillScreen(255*!Dark);
            gfx_SetTextScale(3,4);
            gfx_PrintStringXY("SPLAT",100,14);
            ModeMenu();
            MenuCurs(20,45*Mopt+22);
            gfx_FloodFill(28,45*Mopt+30,Paint[randInt(0,4)]);
            while (kb_AnyKey());
        }
    }
}

void CustomMenu(void) {
    uint8_t b,d;
    uint16_t menux[] = {123,164,205,246,287},a,c; // 41
    gfx_SetColor(255*Dark);
    gfx_SetTextScale(1,1);
    
    for(a=9;a<240;a+=77) { // 9 pix of space
        gfx_Rectangle_NoClip(110,a,205,69);
        gfx_Rectangle_NoClip(109,a+1,207,67);
    }
    gfx_PrintStringXY("Collect",40,39);
    gfx_PrintStringXY("Protect",40,116);
    gfx_PrintStringXY("Subtract",40,193);
    for(c=67,d=0;c<240;c+=77,d++) {
        for(a=151,b=0;a<320;a+=41,b++) { // 205/5
            gfx_VertLine_NoClip(a,c-57,67);
            gfx_FloodFill(a-2,c-56,Paint[b]);
            if (b==Copt[d]) {
                MenuCurs(menux[b],c-32);
                gfx_FloodFill(menux[b]+8,c-24,149);
            }
        }
    }
    Character(20,120,15);
}

void Custom(void) {
    uint8_t menu=1,menu2;
    uint16_t menux[] = {123,164,205,246,287}; // 12
    CustomMenu();
    MenuCurs(menux[Copt[menu-1]],35+(menu-1)*77);
    while (kb_AnyKey());
    while (!(kb_Data[6] & kb_Clear)) {
        kb_Scan();
        if (kb_Data[7]) {
            if ((kb_Data[7] & kb_Down) || (kb_Data[7] & kb_Up))
                gfx_FloodFill(menux[Copt[menu-1]]+8,35+(menu-1)*77+8,149);
            else {
                gfx_SetColor(Paint[Copt[menu-1]]);
                gfx_FillRectangle_NoClip(menux[Copt[menu-1]],35+(menu-1)*77,16,16);
            }
            menu+=(kb_Data[7] & kb_Down);
            menu-=(kb_Data[7] & kb_Up)/8;
            if (menu==4) menu=1;
            if (menu==0) menu=3;
            menu2=Copt[menu-1];
            do { // This do-while loop is really cool :P
                Copt[menu-1]+=(kb_Data[7] & kb_Right)/4;
                Copt[menu-1]-=(kb_Data[7] & kb_Left)/2;
            } while ((Copt[0]==Copt[1] || Copt[0]==Copt[2] || Copt[1]==Copt[2]) && (Copt[menu-1]<5));
            if (Copt[menu-1]>=5) Copt[menu-1]=menu2;
            
            Character(20,120,15);
            MenuCurs(menux[Copt[menu-1]],35+(menu-1)*77);
            delay(150);
        }
        if (kb_Data[4] & kb_Prgm) {
            gfx_FillScreen(255*!Dark);
            gfx_SetTextScale(3,4);
            gfx_PrintStringXY("SPLAT",100,14);
            Help();
            gfx_FillScreen(255*!Dark);
            CustomMenu();
            MenuCurs(menux[Copt[menu-1]],35+(menu-1)*77);
            while (kb_AnyKey());
        }
        if (kb_Data[1] & kb_2nd) {
            gfx_FillScreen(255*!Dark);
            Game();
            gfx_FillScreen(255*!Dark);
            CustomMenu();
            MenuCurs(menux[Copt[menu-1]],35+(menu-1)*77);
            while (kb_AnyKey());
        }
    }
}

void Character(uint16_t X, uint8_t Y, uint8_t R) {
    gfx_SetColor(Paint[Copt[2]]); // somehow the colors got reversed?
    gfx_FillCircle_NoClip(X,Y,R);
    gfx_SetColor(Paint[Copt[1]]);
    gfx_FillCircle_NoClip(X,Y,R*2/3);
    gfx_SetColor(Paint[Copt[0]]);
    gfx_FillCircle_NoClip(X,Y,R/3);
}

void Game(void) {
    bool dead=0;
    uint8_t locy=120, speed=2,b,a,siz, szcnt=0, size=8;
    uint16_t locx=305, prj=0, *projc;
    uint24_t score=0;
    projc=malloc(256*6*2); // 256 prj, 6 inst, 16 bits : X,Y,dir,vol,col,siz
    if (Mopt!=1) locx=160;
    gfx_SetTextScale(1, 1);
    srandom(rtc_Time()); // make every game pseudo-unique.
    while (!dead && !(kb_Data[6] & kb_Clear)) { // dead, lol.
        gfx_SetDraw(gfx_buffer);
        kb_Scan();
        gfx_FillScreen(255*!Dark);
        if (kb_Data[7]) {
            locy+=speed*((kb_Data[7] & kb_Down)-(kb_Data[7] & kb_Up)/8);
            if (Mopt==3) {
                locx+=speed*((kb_Data[7] & kb_Right)/4-(kb_Data[7] & kb_Left)/2);
                if (locx<10) locx=10;
                if (locx>310) locx=310;
            }
            if (locy<10) locy=10;
            if (locy>230) locy=230;
        }
        
        for(b=0;b<6*prj;b+=6) {
            siz=projc[b+5];
            gfx_SetColor(Paint[projc[b+4]]);
            gfx_FillCircle(projc[b],projc[b+1],siz);
            if ((Mopt!=4) && (locx-size-siz)<projc[b] && (locx+size+siz)>projc[b] && (locy-size-siz)<projc[b+1] && (locy+size+siz)>projc[b+1]) {
                if (projc[b+4]==Copt[2]) { // sub
                    if (score) score--;
                    else dead=true;
                    szcnt=0;
                    if (size>8) size-=2;
                } else if (projc[b+4]==Copt[0]) { // add
                    score++; szcnt++;
                    if (szcnt==5) {
                        size+=2; szcnt=0;}
                } else if (projc[b+4]!=Copt[1]) // !pro
                    dead=true;
                for(a=b; a<(prj*6); a++)
                    projc[a]=projc[a+6];
                prj--; b-=6;
            }
            // 0=+x (>), 1=-x (<), 2=+y (v), 3=-y (^)
            switch (projc[b+2]) {
                case (0): projc[b  ]+=projc[b+3]; break;
                case (1): projc[b  ]-=projc[b+3]; break;
                case (2): projc[b+1]+=projc[b+3]; break;
                case (3): projc[b+1]-=projc[b+3]; break;
            }
            if (projc[b]>325 || projc[b+1]>245) { // works because unsigned.
                for(a=b; a<(prj*6); a++)
                    projc[a]=projc[a+6];
                prj--; b-=6;
            }
        }
        
        if (!randInt(0,10)) {
            // This fixed a strange bug :/
            projc[6*prj+2]=randInt(0,(Mopt>1)+2*(Mopt>2)); // dir
            switch (projc[6*prj+2]) {
                case (0): case (1):
                    projc[6*prj  ]=5+325*(1==projc[6*prj+2]); // x
                    projc[6*prj+1]=randInt(10,210); // y
                    break;
                case (2): case (3):
                    projc[6*prj  ]=randInt(5,315); // x
                    projc[6*prj+1]=5+240*(3==projc[6*prj+2]); // y
                    break;
            }
            projc[6*prj+3]=randInt(2,6); // vol
            projc[6*prj+4]=randInt(0,4); // col
            projc[6*prj+5]=randInt(5,15); // rad
            prj++;
        }
        if (Mopt!=4) {
            gfx_SetTextXY(2,2);
            gfx_PrintUInt(score,4);
            gfx_SetTextXY(275,2);
            gfx_PrintUInt(HighS[Mopt-1],4);
            if (dead) {
                gfx_TransparentSprite_NoClip(SPLAT_mini,locx-8,locy-8);
                gfx_FloodFill(locx,locy,Paint[Copt[0]]);
            } else Character(locx,locy,size);
        }
        if (kb_Data[1] & kb_Mode || kb_Data[4] & kb_Prgm) {
            gfx_SetColor(255*Dark);
            gfx_Rectangle_NoClip(94,98,132,42);
            gfx_Rectangle_NoClip(93,99,134,40);
            
            gfx_SetTextScale(2,3);
            gfx_PrintStringXY("Paused",113,104);
            gfx_SetTextScale(1,1);
            gfx_PrintStringXY("Press 2nd to begin",98,129);
        Help2: // :3
            if (kb_Data[4] & kb_Prgm) {
                gfx_SetDraw(gfx_screen);
                gfx_FillScreen(255*!Dark);
                gfx_SetTextScale(3,4);
                gfx_PrintStringXY("SPLAT",100,14);
                Help();
            }
            gfx_Blit(gfx_buffer);
            while (kb_AnyKey());
            while (!((kb_Data[1] & kb_2nd) || (kb_Data[6] & kb_Clear) || (kb_Data[4] & kb_Prgm))) kb_Scan();
            if(kb_Data[4] & kb_Prgm) goto Help2;
        } else
            gfx_Blit(gfx_buffer);
    }
    
    if (HighS[Mopt-1]<score)
        HighS[Mopt-1]=score;
    
    free(projc); // oops, almost forgot
    gfx_SetDraw(gfx_screen);
    
    if (Mopt!=4 && !(kb_Data[6] & kb_Clear)) {
        gfx_SetColor(255*Dark);
        gfx_Rectangle_NoClip(96,105,128,30);
        gfx_Rectangle_NoClip(95,106,130,28);
        gfx_SetTextScale(2,3);
        gfx_PrintStringXY("You Lost!",100,110);
        
        while (kb_AnyKey());
        while (!((kb_Data[6] & kb_Clear) || (kb_Data[1] & kb_2nd))) kb_Scan();
    }
}
